'***************** (c) 2008 BTC Korporacja ***********************************
'                     http://www kamami.com
'PROJECT  : LED2
'BOARD    : ZL15AVR (with ATmega32 in socket U1)
'COMPILER : BASCOM AVR (v.1.11.9.1)
'
'******************************************************************************
'
'    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
'    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
'    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
'    FROM USE OF THIS SOFTWARE.
'
'******************************************************************************
'
'DESCRIPTION :
'    Simple 7-segment LED display demonstration.
'
'    Settings and connections on ZL15AVR:
'        A (7SEG/con14) - PA0 (con15)
'        B (7SEG/con14) - PA1 (con15)
'        C (7SEG/con14) - PA2 (con15)
'        D (7SEG/con14) - PA3 (con15)
'        E (7SEG/con14) - PA4 (con15)
'        F (7SEG/con14) - PA5 (con15)
'        G (7SEG/con14) - PA6 (con15)
'        . (7SEG/con14) - PA7 (con15)
'
'        0 (7SEG/con14) - PB0 (con16)
'        1 (7SEG/con14) - PB1 (con16)
'        2 (7SEG/con14) - PB2 (con16)
'        3 (7SEG/con14) - PB3 (con16)
'
'******************************************************************************

$regfile = "m32def.dat"
$crystal = 16000000 '16 MHz - turn on external resonator (fuse bits)
$baud = 1200
$hwstack = 64
$swstack = 64
$framesize = 64

Dim Displaycounter As Byte
Dim Digit1 As Byte
Dim Digit2 As Byte
Dim Digit3 As Byte
Dim Digit4 As Byte

Config Timer0 = Timer , Prescale = 256
On Timer0 Sevensegmentdisplay

Enable Interrupts
Enable Timer0


Portb = 255
Porta = 255
Config Portb = Output
Config Porta = Output

Digit1 = Lookup(0 , Digits) ' write digit '0' pattern to Ditig0
Digit2 = Lookup(3 , Digits) ' write digit '1' pattern to Ditig1
Digit3 = Lookup(2 , Digits) ' write digit '2' pattern to Ditig2
Digit4 = Lookup(1 , Digits) ' write digit '3' pattern to Ditig3

Do : Loop : End

' Timer0 overflow handler
Sevensegmentdisplay:

Incr Displaycounter

Select Case Displaycounter
   Case 1 :
      Set Portb.3     ' DS3 off
      Porta = Digit1  ' write digit to port
      Reset Portb.0  ' DS0 on
   Case 2 :
      Set Portb.0     ' DS0 off
      Porta = Digit2  ' write digit to port
      Reset Portb.1  ' DS1 on
   Case 3 :
      Set Portb.1     ' DS1 off
      Porta = Digit3  ' write digit to port
      Reset Portb.2  ' DS2 on
   Case 4 :
      Set Portb.2    ' DS2 off
      Porta = Digit4 ' write digit to port
      Reset Portb.3 ' DS3 on
      Displaycounter = 0
End Select

Return

'Digits patterns
Digits:
Data 192 , 249 , 164 , 176 , 153 , 146 , 130 , 248 , 128 , 144 , 136 , 131 , 198 , 161 , 134 , 142