'***************** (c) 2008 BTC Korporacja ***********************************
'                     http://www kamami.com
'PROJECT  : CHAR LCD
'BOARD    : ZL15AVR (with ATmega32 in socket U1)
'COMPILER : BASCOM AVR (v.1.11.9.1)
'
'******************************************************************************
'
'    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
'    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
'    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
'    FROM USE OF THIS SOFTWARE.
'
'******************************************************************************
'
'DESCRIPTION :
'    Using LCD character display (HD44780 compatible) in 4-bit mode.
'
'    Settings and connections on ZL15AVR:
'        JP4 (DISPLAY) - 2-3 (=CHAR)
'
'        D4 (LCD_CHAR/con13) - PD4 (con18)
'        D5 (LCD_CHAR/con13) - PD5 (con18)
'        D6 (LCD_CHAR/con13) - PD6 (con18)
'        D7 (LCD_CHAR/con13) - PD7 (con18)
'        E  (LCD_CHAR/con13) - PB2 (con16)
'        RS (LCD_CHAR/con13) - PB0 (con16)
'        RW (LCD_CHAR/con13) - GND (con15)
'
'
'******************************************************************************

$regfile = "m32def.dat"
$crystal = 16000000                                         '16 MHz - turn on external resonator (fuse bits)
$baud = 1200
$hwstack = 64
$swstack = 64
$framesize = 64

Dim Temp As Byte

Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portb.2 , Rs = Portb.0

Initlcd
Cls
Cursor Off

Lcd " -- ZL15AVR -- ZL15AVR --"
Lowerline
Lcd " Kamami Development Board"

Do

  For Temp = 1 To 10
     Shiftlcd Left                                          'shift the text to the left
     Waitms 400
  Next

  Waitms 400

  For Temp = 1 To 10
     Shiftlcd Right                                         'shift the text to the right
     Waitms 400
  Next

  Waitms 400

Loop

End