'***************** (c) 2008 BTC Korporacja ***********************************
'                     http://www kamami.com
'PROJECT  : CHAR LCD
'BOARD    : ZL15AVR (with ATmega32 in socket U1)
'COMPILER : BASCOM AVR (v.1.11.9.1)
'
'******************************************************************************
'
'    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
'    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
'    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
'    FROM USE OF THIS SOFTWARE.
'
'******************************************************************************
'
'DESCRIPTION :
'    Using LCD graphic display (KS0108 compatible)
'
'    Settings and connections on ZL15AVR:
'        JP4 (DISPLAY) - 1-2 (=GRAPH)
'
'        D0 (LCD_GRAPH/con12) - PA0 (con15)
'        D1 (LCD_GRAPH/con12) - PA1 (con15)
'        D2 (LCD_GRAPH/con12) - PA2 (con15)
'        D3 (LCD_GRAPH/con12) - PA3 (con15)
'        D4 (LCD_GRAPH/con12) - PA4 (con15)
'        D5 (LCD_GRAPH/con12) - PA5 (con15)
'        D6 (LCD_GRAPH/con12) - PA6 (con15)
'        D7 (LCD_GRAPH/con12) - PA7 (con15)
'

'        RS (LCD_GRAPH/con12) - PC0 (con17)
'        RW (LCD_GRAPH/con12) - PC1 (con17)
'        E  (LCD_GRAPH/con12) - PC2 (con17)
'        CS1(LCD_GRAPH/con12) - PC4 (con17)
'        CS2(LCD_GRAPH/con12) - PC3 (con17)
'
'******************************************************************************

$regfile = "m32def.dat"
$crystal = 16000000                                         '16 MHz - turn on external resonator (fuse bits)
$baud = 1200
$hwstack = 64
$swstack = 64
$framesize = 64

$include "font6x8.font"
$lib "glcdKS108.lbx"

Config Graphlcd = 128 * 64sed , Dataport = Porta , Controlport = Portc , Ce = 3 , Ce2 = 4 , Cd = 0 , Rd = 1 , Reset = 5 , Enable = 2

Cls
Setfont Font5x8

Do
Cls
Lcdat 1 , 12 , "   K A M A M I"
Lcdat 2 , 12 , "development board"

Lcdat 4 , 12 , " -- ZL15AVR --  "
Lcdat 5 , 12 , " www.kamami.com "

Wait 2

Showpic 0 , 0 , Kamami

Wait 2


Loop
End

Kamami:
$bgf "kamami.bgf"