'***************** (c) 2008 BTC Korporacja ***********************************
'                     http://www kamami.com
'PROJECT  : RTC
'BOARD    : ZL15AVR (with ATmega32 in socket U1)
'COMPILER : BASCOM AVR (v.1.11.9.1)
'
'******************************************************************************
'
'    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
'    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
'    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
'    FROM USE OF THIS SOFTWARE.
'
'******************************************************************************
'
'DESCRIPTION :
'    Simple I2C communication demo.
'    Read time from RTC (U6 - M41T00)
'    and transmit it to PC via UART.
'
'    Settings and connections on ZL15AVR:
'        SCL (U6 RTC/con7) - PC0 (con17)
'        SDA (U6 RTC/con7) - PC1 (con17)
'
'      if RS232 cable connected:
'        RxD (con7) - PD0 (con18)
'        TxD (con7) - PD1 (con18)
'
'      if UART2USB converter (ZL1USB_A or ZL4USB) connected:
'        RxU (con7) - PD0 (con18)
'        TxU (con7) - PD1 (con18)
'
'******************************************************************************

$regfile = "m32def.dat"
$crystal = 16000000                                         '16 MHz - turn on external resonator (fuse bits)
$baud = 1200
$hwstack = 64
$swstack = 64
$framesize = 64

$lib"i2c_twi.lbx"
Config Twi = 100000

Config Scl = Portc.0
Config Sda = Portc.1

Const M41t00_address_wr = &HD0
Const M41t00_address_rd = &HD1

Dim B1 As Byte , I As Byte

Print
Print "*************************"
Print "**     ZL15AVR  RTC    **"
Print "**    www.kamami.com   **"
Print "*************************"


Do
  Print "M41T00"

  I2cstart
  I2cwbyte M41t00_address_wr                                'write addres of M41T00
  I2cwbyte 2                                                'select hours register
  I2cstart                                                  'repeated start
  I2cwbyte M41t00_address_rd                                'write address for reading data
  I2crbyte B1 , Nack
  I2cstop
  I = B1 And &H30
  Shift I , Right , 4
  Print I ;
  I = B1 And &H0F
  Print I ; ":" ;

  I2cstart
  I2cwbyte M41t00_address_wr                                'write addres of M41T00
  I2cwbyte 1                                                'select minutes register
  I2cstart                                                  'repeated start
  I2cwbyte M41t00_address_rd                                'write address for reading data
  I2crbyte B1 , Nack
  I2cstop
  I = B1 And &H70
  Shift I , Right , 4
  Print I ;
  I = B1 And &H0F
  Print I ; ":" ;

  I2cstart
  I2cwbyte M41t00_address_wr                                'write addres of M41T00
  I2cwbyte 0                                                'select seconds register
  I2cstart                                                  'repeated start
  I2cwbyte M41t00_address_rd                                'write address for reading data
  I2crbyte B1 , Nack
  I2cstop
  I = B1 And &H70
  Shift I , Right , 4
  Print I ;
  I = B1 And &H0F
  Print I

  Print "------------------------------------------ "
  Print
  Waitms 200

Loop


End